//   Copyright (c)  2017 John Abbott, Anna M. Bigatti
//   Authors: 2017 Anna M. Bigatti, Alberto Griggio

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.


// Source code for MathSAT integration

#include "CoCoA/ExternalLibs-MathSAT.H"

#ifdef CoCoA_WITH_MATHSAT

// #include "CoCoA/BigInt.H"
// #include "CoCoA/BigRat.H"
// #include "CoCoA/IntOperations.H"
// #include "CoCoA/TmpPPVector.H"
// #include "CoCoA/convert.H"
// #include "CoCoA/error.H"
// #include "CoCoA/DenseMatrix.H"
// #include "CoCoA/matrix.H"
// #include "CoCoA/SparsePolyRing.H"
// #include "CoCoA/symbol.H"
// #include "CoCoA/RingZZ.H"

// #include "CoCoA/VectorOperations.H"  // just for debugging

// #include <vector>
// using std::vector;
// #include <ostream>
// using std::ostream;
// using std::endl;
// #include <sstream>  // for ErrorMessage


namespace CoCoA
{

  namespace MathSAT  // "mathsat" is its own namespace
  {

    namespace  // conversion functions, implementation at the end of the file
    {

      

    } // end of anonymous namespace

//     class ConeImpl: protected IntrusiveReferenceCount
//     {
//       friend class SmartPtrIRC<const ConeImpl>; // Morally "friend Cone", so it can alter reference count.
      
//     public:
//       ConeImpl(ConstMatrixView IneqMat, ConstMatrixView EqMat);
      
//     public:
//       friend  ostream& operator<< (ostream& out, const cone& C);
//       friend  matrix equations(const cone& C);
//       friend  matrix inequalities(const cone& C);
//       friend  matrix RelativeInteriorPoint(const cone& C);
//       friend  matrix GeneratorsOfSpan(const cone& C);
//       friend  matrix GeneratorsOfLinealitySpace(const cone& C);
//       friend  matrix GetFacets(const cone& C);
//       friend  matrix GetImpliedEquations(const cone& C);
//       friend  matrix GetUniquePoint(const cone& C);
//       friend  long GetAmbientDimension(const cone& C);
//       friend  long GetDimension(const cone& C);
//       friend  long GetCodimension(const cone& C);
//       friend  long GetDimensionOfLinealitySpace(const cone& C);
//       friend  cone GetDimensionOfLinealitySpace(const cone& C, const cone & D);
//       friend  bool ContainsPositiveVector(const cone& C);
      

//     private: // data members
//       ZCone myZCone;
//     };
    


    // printing
//     ostream& operator<< (ostream& out, const cone& C)
//     {
//       if (!out) return out;  // short-cut for bad ostreams
//       using namespace mathsat;
//       out << C->myZCone.toString();
//       return out;
//     }
    
//     matrix equations(const cone& C)
//     { return ConvertMat(C->myZCone.getEquations()); }
    
//     matrix inequalities(const cone& C)
//     { return ConvertMat(C->myZCone.getInequalities()); }
  

  } // namespace mathsatlib
} // namespace CoCoA

// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/src/AlgebraicCore/ExternalLibs-MathSAT.C,v 1.3 2017/04/27 16:18:50 bigatti Exp $
// $Log: ExternalLibs-MathSAT.C,v $
// Revision 1.3  2017/04/27 16:18:50  bigatti
// -- changed copyright
//
// Revision 1.2  2017/03/13 12:30:37  abbott
// Summary: Move #ifdef guard to after inclusion of header file (so that defns from PREPROCESSOR_DEFNS.H are visible)
//
// Revision 1.1  2017/02/24 08:20:31  bigatti
// -- first import
//

#endif
